// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.operation;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2013 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */


/**
 * <p>
 * Opération éffectuée dans le cadre d'une marée (observée en mer,
 * observée au débarquement, campagne en mer,  marée déclarée,
 * etc.).
 * </p>
 * <p>
 * Une opération peut etre une opération de peche ou non. Par
 * exemple, au cours de campagne à la mer, le navire peut déployer
 * des engins de collecte de données environnementales
 * (température, salinité, etc. ).
 * </p>
 */
public abstract class Operation
    implements java.io.Serializable
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 4065992805884536005L;

    private java.lang.Integer id;

    /**
     * <p>
     * Identifiant unique de l'opération.
     * </p>
     */
    public java.lang.Integer getId()
    {
        return this.id;
    }

    public void setId(java.lang.Integer id)
    {
        this.id = id;
    }

    private java.lang.String name;

    /**
     * <p>
     * @deprecated - NE PLUS UTILISER
     * </p>
     * <p>
     * Libellé de l'opération.
     * </p>
     * <p>
     * REMARQUE : attribut absent des IHM. Présent pour les données
     * historiques. Sans doute à supprimer dans l'avenir.
     * </p>
     */
    public java.lang.String getName()
    {
        return this.name;
    }

    public void setName(java.lang.String name)
    {
        this.name = name;
    }

    private java.lang.Short rankOrderOnPeriod;

    /**
     * <p>
     * Rang (de présentation) de l'opération, sur la période date
     * début/fin.
     * </p>
     * <p>
     * ATTENTION : Lorsque plusieurs opérations sont présentes sur la
     * meme période, cela permet de les dissocier.
     * </p>
     * <p>
     * C'est par exemple le cas des séquences de peches (opérations
     * agrégées en Jour/Métier/Secteur) : plusieurs opérations peuvent
     * etre sur le meme jour (avec des engin/secteur différents), il
     * faut donc leur attribuer un rang, pour les distinguer. Ce rang
     * peut etre celui de la déclaration du pecheur (ordre de saisie),
     * ou bien un ordre quelconque.
     * </p>
     * <p>
     * Dans Allegro, ce rang sera utilisé pour ordonner ces opérations
     * entre elles, dans les listes qui les représentent. S'il est
     * absent, seule la date de début est utilisée pour cela.
     * </p>
     */
    public java.lang.Short getRankOrderOnPeriod()
    {
        return this.rankOrderOnPeriod;
    }

    public void setRankOrderOnPeriod(java.lang.Short rankOrderOnPeriod)
    {
        this.rankOrderOnPeriod = rankOrderOnPeriod;
    }

    private java.util.Date startDateTime;

    /**
     * <p>
     * Date/heure de début de l'opération
     * </p>
     */
    public java.util.Date getStartDateTime()
    {
        return this.startDateTime;
    }

    public void setStartDateTime(java.util.Date startDateTime)
    {
        this.startDateTime = startDateTime;
    }

    private java.util.Date endDateTime;

    /**
     * <p>
     * Date/heure de fin de l'opération
     * </p>
     */
    public java.util.Date getEndDateTime()
    {
        return this.endDateTime;
    }

    public void setEndDateTime(java.util.Date endDateTime)
    {
        this.endDateTime = endDateTime;
    }

    private java.lang.Boolean isMainOperation;

    /**
     * <p>
     * <html>
     * </p>
     * <p>
     * <head>
     * </p>
     * <p>
     * </head>
     * </p>
     * <p>
     * <body>
     * </p>
     * <p>
     * <p>
     * </p>
     * <p>
     * Indique s'il s'agit d'une op&#233;ration ou d'un groupe
     * d'op&#233;rations
     * </p>
     * <p>
     * &quot;principal&quot;.
     * </p>
     * <p>
     * </p>
     * </p>
     * <p>
     * <p>
     * </p>
     * <p>
     * Cela est utilis&#233; notamment quand on ne connait que
     * l'activit&#233; principale
     * </p>
     * <p>
     * (le m&#233;tier) d'un navire. On parle alors de m&#233;trier
     * principal.
     * </p>
     * <p>
     * <br>    </p>
     * </p>
     * <p>
     * <p>
     * </p>
     * <p>
     * </p>
     * </p>
     * <p>
     * <p>
     * </p>
     * <p>
     * G&#233;n&#233;ralement, cet atrribut est utilis&#233; pour des
     * groupes d'op&#233;rations (<i>rankOrderOnPerod
     * </p>
     * <p>
     * is not null</i>), pou identifier sur la mar&#233;e ou une
     * journ&#233;e de peche,
     * </p>
     * <p>
     * le groupe d'op&#233;ration portant le m&#233;tier principal de
     * la mar&#233;e ou de la
     * </p>
     * <p>
     * journ&#233;e.
     * </p>
     * <p>
     * </p>
     * </p>
     * <p>
     * </body>
     * </p>
     * <p>
     * </html>
     * </p>
     */
    public java.lang.Boolean getIsMainOperation()
    {
        return this.isMainOperation;
    }

    public void setIsMainOperation(java.lang.Boolean isMainOperation)
    {
        this.isMainOperation = isMainOperation;
    }

    private java.lang.String position;

    /**
     * <p>
     * Géométrie de l'opération.
     * </p>
     * <p>
     * Ce champ est optionnel pour etre compatible avec uDIG/geotools.
     * </p>
     */
    public java.lang.String getPosition()
    {
        return this.position;
    }

    public void setPosition(java.lang.String position)
    {
        this.position = position;
    }

    private java.lang.String comments;

    /**
     * 
     */
    public java.lang.String getComments()
    {
        return this.comments;
    }

    public void setComments(java.lang.String comments)
    {
        this.comments = comments;
    }

    private java.util.Date controlDate;

    /**
     * 
     */
    public java.util.Date getControlDate()
    {
        return this.controlDate;
    }

    public void setControlDate(java.util.Date controlDate)
    {
        this.controlDate = controlDate;
    }

    private java.util.Date validationDate;

    /**
     * 
     */
    public java.util.Date getValidationDate()
    {
        return this.validationDate;
    }

    public void setValidationDate(java.util.Date validationDate)
    {
        this.validationDate = validationDate;
    }

    private java.util.Date qualificationDate;

    /**
     * 
     */
    public java.util.Date getQualificationDate()
    {
        return this.qualificationDate;
    }

    public void setQualificationDate(java.util.Date qualificationDate)
    {
        this.qualificationDate = qualificationDate;
    }

    private java.lang.String qualificationComments;

    /**
     * 
     */
    public java.lang.String getQualificationComments()
    {
        return this.qualificationComments;
    }

    public void setQualificationComments(java.lang.String qualificationComments)
    {
        this.qualificationComments = qualificationComments;
    }


    private fr.ifremer.adagio.core.dao.referential.QualityFlag qualityFlag;

    /**
     * <p>
     * Niveau de qualité de la donnée.
     * </p>
     * <p>
     * "Non qualifiée" par défaut
     * </p>
     */
    public fr.ifremer.adagio.core.dao.referential.QualityFlag getQualityFlag()
    {
        return this.qualityFlag;
    }

    public void setQualityFlag(fr.ifremer.adagio.core.dao.referential.QualityFlag qualityFlag)
    {
        this.qualityFlag = qualityFlag;
    }


    private fr.ifremer.adagio.core.dao.data.vessel.Vessel vessel;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.data.vessel.Vessel getVessel()
    {
        return this.vessel;
    }

    public void setVessel(fr.ifremer.adagio.core.dao.data.vessel.Vessel vessel)
    {
        this.vessel = vessel;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.data.operation.OperationVesselAssociation> operationVesselAssociations = new java.util.HashSet<fr.ifremer.adagio.core.dao.data.operation.OperationVesselAssociation>();

    /**
     * 
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.data.operation.OperationVesselAssociation> getOperationVesselAssociations()
    {
        return this.operationVesselAssociations;
    }

    public void setOperationVesselAssociations(java.util.Collection<fr.ifremer.adagio.core.dao.data.operation.OperationVesselAssociation> operationVesselAssociations)
    {
        this.operationVesselAssociations = operationVesselAssociations;
    }



    private fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip fishingTrip;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip getFishingTrip()
    {
        return this.fishingTrip;
    }

    public void setFishingTrip(fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip fishingTrip)
    {
        this.fishingTrip = fishingTrip;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.data.vessel.feature.use.VesselUseFeatures> vesselUseFeatures = new java.util.HashSet<fr.ifremer.adagio.core.dao.data.vessel.feature.use.VesselUseFeatures>();

    /**
     * 
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.data.vessel.feature.use.VesselUseFeatures> getVesselUseFeatures()
    {
        return this.vesselUseFeatures;
    }

    public void setVesselUseFeatures(java.util.Collection<fr.ifremer.adagio.core.dao.data.vessel.feature.use.VesselUseFeatures> vesselUseFeatures)
    {
        this.vesselUseFeatures = vesselUseFeatures;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.data.vessel.feature.use.GearUseFeatures> gearUseFeatures = new java.util.HashSet<fr.ifremer.adagio.core.dao.data.vessel.feature.use.GearUseFeatures>();

    /**
     * 
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.data.vessel.feature.use.GearUseFeatures> getGearUseFeatures()
    {
        return this.gearUseFeatures;
    }

    public void setGearUseFeatures(java.util.Collection<fr.ifremer.adagio.core.dao.data.vessel.feature.use.GearUseFeatures> gearUseFeatures)
    {
        this.gearUseFeatures = gearUseFeatures;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.data.vessel.feature.person.VesselPersonFeatures> vesselPersonFeatures = new java.util.HashSet<fr.ifremer.adagio.core.dao.data.vessel.feature.person.VesselPersonFeatures>();

    /**
     * 
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.data.vessel.feature.person.VesselPersonFeatures> getVesselPersonFeatures()
    {
        return this.vesselPersonFeatures;
    }

    public void setVesselPersonFeatures(java.util.Collection<fr.ifremer.adagio.core.dao.data.vessel.feature.person.VesselPersonFeatures> vesselPersonFeatures)
    {
        this.vesselPersonFeatures = vesselPersonFeatures;
    }


    private fr.ifremer.adagio.core.dao.data.vessel.feature.physical.GearPhysicalFeatures gearPhysicalFeatures;

    /**
     * <p>
     * Caractéristiques physique de l'engin déployé au cours de
     * l'opération.
     * </p>
     * <p>
     * Si l'opération est une opération de prélèvement, l'engin est
     * forcément d'un engin de peche.
     * </p>
     * <p>
     * Exemple de caratéristiques physiques :
     * </p>
     * <p>
     * • engin : OTB (Chalut)
     * </p>
     * <p>
     * • longueur de la corde de dos
     * </p>
     * <p>
     * • largeur du maillage
     * </p>
     * <p>
     * • type de matériaux du fil
     * </p>
     */
    public fr.ifremer.adagio.core.dao.data.vessel.feature.physical.GearPhysicalFeatures getGearPhysicalFeatures()
    {
        return this.gearPhysicalFeatures;
    }

    public void setGearPhysicalFeatures(fr.ifremer.adagio.core.dao.data.vessel.feature.physical.GearPhysicalFeatures gearPhysicalFeatures)
    {
        this.gearPhysicalFeatures = gearPhysicalFeatures;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.data.vessel.position.VesselPosition> vesselPositions = new java.util.HashSet<fr.ifremer.adagio.core.dao.data.vessel.position.VesselPosition>();

    /**
     * <p>
     * Positions du navires durant l'opération
     * (date/heure/latitute/longitude).
     * </p>
     * <p>
     * La première position (en date/heure) correspond au début de
     * l'opération.
     * </p>
     * <p>
     * La dernière position (en date/heure) correspond à la fin de
     * l'opération.
     * </p>
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.data.vessel.position.VesselPosition> getVesselPositions()
    {
        return this.vesselPositions;
    }

    public void setVesselPositions(java.util.Collection<fr.ifremer.adagio.core.dao.data.vessel.position.VesselPosition> vesselPositions)
    {
        this.vesselPositions = vesselPositions;
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Operation))
        {
            return false;
        }
        final Operation that = (Operation)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (id == null ? 0 : id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link fr.ifremer.adagio.core.dao.data.operation.Operation}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.data.operation.Operation}.
         */
        public static fr.ifremer.adagio.core.dao.data.operation.Operation newInstance()
        {
            final fr.ifremer.adagio.core.dao.data.operation.Operation entity = new fr.ifremer.adagio.core.dao.data.operation.OperationImpl();
			return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.data.operation.Operation}, taking all required and/or
         * read-only properties as arguments.
         */
        public static fr.ifremer.adagio.core.dao.data.operation.Operation newInstance(fr.ifremer.adagio.core.dao.referential.QualityFlag qualityFlag, fr.ifremer.adagio.core.dao.data.vessel.Vessel vessel)
        {
            final fr.ifremer.adagio.core.dao.data.operation.Operation entity = newInstance();
            entity.setQualityFlag(qualityFlag);
            entity.setVessel(vessel);
            return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.data.operation.Operation}, taking all possible properties
         * (except the identifier(s))as arguments.
         */
        public static fr.ifremer.adagio.core.dao.data.operation.Operation newInstance(java.lang.String name, java.lang.Short rankOrderOnPeriod, java.util.Date startDateTime, java.util.Date endDateTime, java.lang.Boolean isMainOperation, java.lang.String position, java.lang.String comments, java.util.Date controlDate, java.util.Date validationDate, java.util.Date qualificationDate, java.lang.String qualificationComments, fr.ifremer.adagio.core.dao.referential.QualityFlag qualityFlag, fr.ifremer.adagio.core.dao.data.vessel.Vessel vessel, java.util.Collection<fr.ifremer.adagio.core.dao.data.operation.OperationVesselAssociation> operationVesselAssociations, fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip fishingTrip, java.util.Collection<fr.ifremer.adagio.core.dao.data.vessel.feature.use.VesselUseFeatures> vesselUseFeatures, java.util.Collection<fr.ifremer.adagio.core.dao.data.vessel.feature.use.GearUseFeatures> gearUseFeatures, java.util.Collection<fr.ifremer.adagio.core.dao.data.vessel.feature.person.VesselPersonFeatures> vesselPersonFeatures, fr.ifremer.adagio.core.dao.data.vessel.feature.physical.GearPhysicalFeatures gearPhysicalFeatures, java.util.Collection<fr.ifremer.adagio.core.dao.data.vessel.position.VesselPosition> vesselPositions)
        {
            final fr.ifremer.adagio.core.dao.data.operation.Operation entity = newInstance();
            entity.setName(name);
            entity.setRankOrderOnPeriod(rankOrderOnPeriod);
            entity.setStartDateTime(startDateTime);
            entity.setEndDateTime(endDateTime);
            entity.setIsMainOperation(isMainOperation);
            entity.setPosition(position);
            entity.setComments(comments);
            entity.setControlDate(controlDate);
            entity.setValidationDate(validationDate);
            entity.setQualificationDate(qualificationDate);
            entity.setQualificationComments(qualificationComments);
            entity.setQualityFlag(qualityFlag);
            entity.setVessel(vessel);
            entity.setOperationVesselAssociations(operationVesselAssociations);
            entity.setFishingTrip(fishingTrip);
            entity.setVesselUseFeatures(vesselUseFeatures);
            entity.setGearUseFeatures(gearUseFeatures);
            entity.setVesselPersonFeatures(vesselPersonFeatures);
            entity.setGearPhysicalFeatures(gearPhysicalFeatures);
            entity.setVesselPositions(vesselPositions);
            return entity;
        }
    }
    
// Operation.java merge-point
}